comment %

ACPI structure dumper.  

Displays ACPI Root Descriptor, FACP and FACS tables to the screen.
Capture the data to a file by executing "acpidump >filename.txt"


Jeff Leyda
jeff@silent.net

Written sometime in November 2002.


You are free to use any bit of this code you like for whatever purpose suits
your fancy.  Just don't come knockin' on my door if it breaks.

%

       	.DOSSEG
        .MODEL  small, c, os_dos

.386

        extern  himemInit:NEAR
	extern	printReg:NEAR
        extern  rsdptrSearch:NEAR
        extern  rsdptrDisplay:NEAR
	extern	RSDTTableDisplay:NEAR
        extern  facpTableDisplay:NEAR
        extern  facsTableDisplay:NEAR
        extern  tables:DWORD

        INCLUDE constant.inc
	INCLUDE macros.inc


FACP_SIG        EQU     'PCAF'  ; FACP table
FACS_SIG        EQU     'SCAF'  ; FACS table


        .CODE
        .STARTUP



;----------------------------------------------------------------------------
; Main entry point.  
;----------------------------------------------------------------------------

	push	cs
	pop	ds

	call	rsdptrSearch		; attempt to find root table
	jc	notACPI

writelncr '---------------------- Root System Description Information ------------------'

	call	rsdptrDisplay		; exits with ESI pointing to RSDT


	call	himemInit		; attempt to set flat real mode
	jc	HimemLoaded		; Not running in real mode? abort!
        
        push    cs
        pop     ds
        
writelncr '--------------------------- Root System Description Table -------------------'

	call	RSDTTableDisplay	; print root table 



	; now we have an array of tables that we need to display.


	lea	bx, cs:tables		
        sub     bx, 4

doNextTable:	
        add     bx, 4
        mov	esi, cs:[bx]
	cmp	esi, 0			; finished?
	jz	exit


	; this currently only supports FACP and FACS tables.
	; Additional tables (and their corresponding signatures) should be
	; added here.


	cmp	dword ptr gs:[esi], FACP_SIG
	jz	doFacp

	cmp	dword ptr gs:[esi], FACS_SIG
	jz	doFacs

	jmp	doNextTable



doFacp:
writelncr '------------------------- Fixed ACPI Description Table ----------------------'

        call    facpTableDisplay


        jmp     doNextTable

doFacs:
writelncr '----------------------- Firmware ACPI Control Structure -------------------'

        call    facsTableDisplay


        jmp     doNextTable




himemLoaded:
	writelncr ' '
	writelnCR '!!!!!!!!! ERROR !!!!!!!!!!!!'
	writelnCR 'Unable to continue: Himem.sys loaded.'
	writelnCR 'This program only works in Safe Mode Command Prompt only.'
        writelnCR 'Reboot to clean DOS and try again.'
	jmp	exit


notACPI:
        
        writelnCr 'Unable to locate Root Description Table.'
        writelncr 'Are you sure this is an ACPI enabled system?'
        writelncr 'Check BIOS setup options to enable ACPI support.'
        jmp     exit

exit:
	


	mov	ax, 4c01h
	int	21h



;
; Global data.  Needs to be in CS so we always know where it is.
;

;public flags
;flags           dd      BINARY_DISPLAY+STATUS_DISPLAY

;public exitCode
;exitCode        db      0               ; errorlevel

;public dumpmode
;dumpmode        db      bytes           ; start with BYTE display

;public rowandcol
;rowandcol       dw      0               ; position to display a character
	
RSDPTR  db      "RSD PTR ",0

.DATA





End

