comment %

ACPI support routines

%

       	.DOSSEG
        .MODEL  small, c, os_dos

.386

        extern  search:NEAR
        extern  printReg:NEAR
        extern  displayTable:NEAR


        INCLUDE constant.inc
	INCLUDE macros.inc


        .CODE



; entry: esi = pointer to system table
; 
;
facpTableDisplay proc public

        call    displayTable

        
        writeln 'Firmware Control Structure Pointer:' ; 4 bytes
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '



        writeln 'Diff. System Descriptor Table:' ; 4 bytes
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '

        
        writeln 'Interrupt Mode (0=Dual PIC, 1=Multiple Apic):'
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '


        inc     esi                             ; reserved


        writeln 'SCI Interrupt Pin:'            ; 2 bytes
        mov     ax, gs:[esi]
        add     esi, 2
        mov     cx, 4
        call    printReg
        writelncr ' '


        writeln 'SMI Command Port address:' ; 4 bytes
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '

        
        writeln 'ACPI SMI Enable Value:'        ; 1 byte
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '


; offset 53

        writeln 'ACPI SMI Disable Value:'        ; 1 byte
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '


; offset 54

        writeln 'S4 BIOS Value (0=unsupported):'   ; 1 byte
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '


        inc     esi                             ; reserved

; offset 56

        writeln 'PM 1A Event Port address:' ; 4 bytes
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '


        writeln 'PM 1B Event Port address:' ; 4 bytes
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '


        writeln 'PM 1A Control Port address:' ; 4 bytes
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '

; offset 68
        writeln 'PM 1B Control Port address:' ; 4 bytes
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '


        writeln 'PM 2 Control Port address:' ; 4 bytes
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '

        writeln 'PM Timer Port address:' ; 4 bytes
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '

        writeln 'GP Event 0 Port address:' ; 4 bytes
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '

        writeln 'GP Event 1 Port address:' ; 4 bytes
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '

; offset 88

        writeln 'PM1 Event Length:'   ; 1 byte
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '

        writeln 'PM1 Control Length:'   ; 1 byte
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '

        writeln 'PM2 Control Length:'   ; 1 byte
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '

        writeln 'Timer Length:'   ; 1 byte
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '

        writeln 'GP Event 0 Length:'   ; 1 byte
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '

; offset 93
        writeln 'GP Event 1 Length:'   ; 1 byte
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '


        writeln 'GP Event 1 Base offset:'   ; 1 byte
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '

        inc     esi                             ; reserved offset 95


        writeln 'C2 Hardware Latency:'            ; 2 bytes
        mov     ax, gs:[esi]
        add     esi, 2
        mov     cx, 4
        call    printReg
        writelncr 'ms'

        writeln 'C3 Hardware Latency:'            ; 2 bytes
        mov     ax, gs:[esi]
        add     esi, 2
        mov     cx, 4
        call    printReg
        writelncr 'ms'

        writeln 'Flush Size:'            ; 2 bytes
        mov     ax, gs:[esi]
        add     esi, 2
        mov     cx, 4
        call    printReg
        writelncr ' '

; offset 102
        writeln 'Flush Stride:'            ; 2 bytes
        mov     ax, gs:[esi]
        add     esi, 2
        mov     cx, 4
        call    printReg
        writelncr ' '

        writeln 'Duty Offset:'   ; 1 byte
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '

        writeln 'Duty Width:'   ; 1 byte
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '

        writeln 'CMOS Day Alarm index:'   ; 1 byte
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '

        writeln 'CMOS Month Alarm index:'   ; 1 byte
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '
        
        writeln 'CMOS Century Alarm index:'   ; 1 byte
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '

        add     esi, 3                        ; reserved

; offset 112

        writeln 'Fixed Feature Flags:' ; 4 bytes
        mov     eax, gs:[esi]
        mov     edi, eax
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '


; flags.


        writeln '                 BIT 0:WBIVD '
        test    edi, BIT0
        jz      @f

        writelncr 'supported.'
        jmp     flag1
@@:
        writelncr 'not supported.'

flag1:

        writeln '                 BIT 1:WBIVD Flush '
        test    edi, BIT1
        jz      @f

        writelncr 'supported.'
        jmp     flag2
@@:
        writelncr 'not supported.'



flag2:
        writeln '                 BIT 2:Processor C1 state '
        test    edi, BIT2
        jz      @f

        writelncr 'supported.'
        jmp     flag3
@@:
        writelncr 'Not Supported.'



flag3:
        writeln '                 BIT 3:C2 Multiprocessor  '
        test    edi, BIT3
        jz      @f

        writelncr 'supported.'
        jmp     flag4
@@:
        writelncr 'Not Supported.'



flag4:
        writeln '                 BIT 4:Power Button  '
        test    edi, BIT4
        jnz     @f

        writelncr 'available.'
        jmp     flag5
@@:
        writelncr 'not available.'




flag5:
        writeln '                 BIT 5:Sleep Button  '
        test    edi, BIT5
        jnz     @f

        writelncr 'available.'
        jmp     flag6
@@:
        writelncr 'not available.'




flag6:
        writeln '                 BIT 6:Fixed RTC '
        test    edi, BIT6
        jz      @f

        writelncr 'not supported.'
        jmp     flag7
@@:
        writelncr 'supported.'




flag7:
        writeln '                 BIT 7:RTC S4 Wake '
        test    edi, BIT7
        jz      @f

        writelncr 'supported.'
        jmp     flag8
@@:
        writelncr 'not supported.'



flag8:
        writeln '                 BIT 8:Timer Value is '
        test    edi, BIT8
        jz      @f

        writelncr '32 Bit.'
        jmp     flag9
@@:
        writelncr '24 Bit'


flag9:
        writeln '                 BIT 9:Docking '
        test    edi, BIT9
        jz      @f

        writelncr 'supported.'
        jmp     flag9
@@:
        writelncr 'not supported'


        ret
facpTableDisplay endp






.DATA





End

