JMPR	MACRO	Register,Destination		; Jump with return to register
	LOCAL	ReturnPoint
	MOV	Register,OFFSET ReturnPoint
	JMP	Destination

ReturnPoint:
ENDM

JMPRBX	MACRO	Destination			; Jump with return to register
	PUBLIC	Destination&Return
	EXTERN	Destination (Destination&Return):NEAR
	MOV	BX,OFFSET Destination&Return
	JMP	Destination

Destination&Return::
ENDM

IODELAYPORT 	equ	0EDh
;;---------------------------------------------------------------------------
;;
;;  IODELAY - Perform a delay cycle between back-to-back IO accesses
;;
;;  IODELAY
;;
;;  Entry:
;;	AL - The dummy data to be written to the IO port.
;;	     The value does not matter.
;;
;;	IODELAYPORT - the unused IO port (00h-FFh) to recieve the data
;;
;;  Exit:
;;	The data in AL is written to IODELAYPORT
;;
;;  Processing:
;;	Performs a delay between back-to-back IO cycles by causing a
;;	write to the specified unused IO port.	This delay is for four
;;	BCLKs.	On a standard AT system with an 8MHz bus clock, this
;;	is approximately 1/2us.
;;
;;  Usage:
;;	IODELAY
;;
IODELAY MACRO

	out	IODELAYPORT, al
ENDM

BIGSTOSD	MACRO
	DB	067h
	DB	066h
	DB	0abh
ENDM

BIGREPSTOSD	MACRO
	db	0f3h
	db	067h
	db	066h
	db	0abh
ENDM

BIGREPSCASD	MACRO
	db	0f3h
	db	067h
	db	066h
	db	0afh
ENDM
BIGREPMOVSD	MACRO
	DB	0f3h
	DB	067h
	DB	066h
	DB	026h
	DB	0a5h
ENDM


;
; writeln
;
; input:
;   textstring
;
; output:
;   none (text displayed on screen) No carrage return at end.
;
; destroys:
;   ax, dx
;   flags
;
; usage: WriteLN('Hello, world!');
;
WRITELN MACRO   _string
LOCAL   _afterstring

        call    _afterstring

db      _string,'$'
_afterstring:
        mov     ah,9
	pop	dx
	int	21h

        ENDM
;
; writelnCR
;
; input:
;   textstring
;
; output:
;   none (text displayed on screen) with a carrage return at end.
;
; destroys:
;   ax, dx
;   flags
;
; usage: WriteLNCR('Hello, world!');
;
WRITELNCR MACRO   _string
LOCAL   _afterstring

        call    _afterstring

db	_string,13,10,'$'
_afterstring:
        mov     ah,9
	pop	dx
	int	21h

        ENDM

DEBUG	EQU	0feh








_DEBUG	macro
local noStop
	pushf
	push	ax
	in	al, 80h
	cmp	al, DEBUG
	pop	ax

	jnz	noStop

	int 3
noStop:
	popf
endm

