comment %

ACPI support routines

%

       	.DOSSEG
        .MODEL  small, c, os_dos

.386

        extern  search:NEAR
        extern  printReg:NEAR


        INCLUDE constant.inc
	INCLUDE macros.inc


        .CODE



;
; searches for the rsd ptr.  Exits with CY set if not found.
; RSD pointer can be in BIOS (E000 and F000 segments)
; or in the EBDA at the top of the first 640k.
;
rsdptrSearch proc
	lea	si, rsdptr
	mov	ax, 0E000h  		; search e000 segment
	mov	es, ax
	mov	cx, -1
	xor	di, di
	call	search
        jnc	@f

	lea	si, rsdptr
	mov	ax, 0F000h		; search f000 segment
	mov	es, ax
	mov	cx, -1
	xor	di, di
        call    search
        jnc     @f

	; search EBDA
	lea	si, rsdptr
	mov	ax, (636 * 1024) / 16	; just below average EBDA
	mov	es, ax
	mov	cx, 4 * 1024		; search 4k
	xor	di, di
	call	search
@@:
	ret

RSDPTR  db      "RSD PTR ",0

rsdptrSearch endp



; entry: es:di points to rsdPtr on entry
;  exit: ESI=pointer to RSDT
rsdptrDisplay proc public

        writeln 'Root System Description Pointer (RSD_PTR_) located at '

	mov	ax, es
	mov	cx, 4
	call	printReg

	writeln ':'

	mov	ax, di
	mov	cx, 4
	call	printReg

	writelncr ' '

	add	di, 8				; length of signature
	mov	al, es:[di]			; offset 8=checksum

	writeln 'Checksum:'
	mov 	cx, 2
	call	printReg

	writelncr ' '

	
	inc	di				; point to OEM id
	writeln 'OEM ID:'
	
	mov	cx, 6				; 6 bytes in length
@@:	
	mov	dl, es:[di]
	mov     ah,2
        int     21h
	inc	di
   	loop 	@b


	writelncr ' '
	writeln '0 Byte:'

	mov	al, es:[di]
	mov	cx, 2
	call	printReg

	inc	di

	writelncr ' '

	writeln 'Physical address of Root Descriptor Table:'
	mov	eax, es:[di]
        mov     esi, eax                        ; return addr in ESI
	mov	cx, 8
	call	printReg

	writelnCR ' '

        ret
rsdptrDisplay endp






.DATA





End

