
        .DOSSEG
        .MODEL  small, c, os_dos

.386
.CODE

        INCLUDE constant.inc


;===========================================================================
;Procedure: PrintReg
;Purpose:   Displays the contents of a register. 
;           Displays data at current cursor location 
;Input:     EAX  Register to print
;           CL   Length of output (8 for full EAX, 4 for AX, 2 for AL...)
;           BP   Color
;Output:    Data written to screen using Stdout 
;Processing: Move nibble into output register, display it, loop til finished 
;---------------------------------------------------------------------------
printReg proc   public

	push    cx
        push    dx
        
	push    cx
        xor     ch, ch
        mov     dx, 8
        sub     dx, cx
        mov     cx, dx
        shl     cx, 2                   ; multply by 4 for shift#
        rol     eax, cl
        pop     cx


nextchar:
	rol     eax,4                      ;print next character
	mov     dl,al                      ;
	and     dl,0fh                     ;strip out upper 4 bits
        call    display_hex_char
	loop    nextchar
	pop	dx	
	pop     cx
	ret
printReg endp
;===========================================================================
;Procedure: Display_hex_char
;Purpose:   Displays the hex value in DL as ASCII
;           Displays data at current cursor location 
;Input:     DL = hex value to print
;           
;Output:    Data printed to screen using Stdout 
;Processing: add 30 or 37 to character, display to screen using int 10
;---------------------------------------------------------------------------
display_hex_char proc        
        push    dx
        add     dl,30h
        cmp     dl,3ah
        jb      charok
        add     dl,7
charok:
        push    ax
        push    bx
        push    cx
        mov     ah,2
        int     21h
        pop     cx
        pop     bx
        pop     ax
        pop     dx
        ret
display_hex_char endp



;===========================================================================
;Procedure: getLenofString
;
;Purpose:   Returns the length of an ASCIIZ string
;           
;Input:     DS:SI points to ASCIIZ string
;           
;Output:    CX returns the length of string, not including terminating NULL
;
;Destroys:  Nothing.
;
;Notes:     Does not return any error status.
;---------------------------------------------------------------------------

getLenOfString  proc

        push    si
        push    ax
        mov     cx, -1                  ; string can be no more than 64k

notzero:
        inc     cx                      ; count bytes
        lodsb
        cmp     al, 0
        jnz     notzero

        pop     ax
        pop     si
        ret
getLenOfString  endp
;===========================================================================
;Procedure: search
;
;Purpose:   find an ASCIIZ string in a buffer.  This is a case sensitive search!
;           
;Input:     DS:SI points to ASCIIZ string
;           ES:DI points to beginning of buffer to search    
;           CX = length of buffer to search
;           
;Output:    ES:DI points to string if found
;           CY set if string is NOT found
;           CY clear if string located.
;
;Destroys:  Nothing.
;
;Notes:     case sensitive!
;           to find the next instance of string, simply call it again.
;           (may need to INC DI by 1)
;---------------------------------------------------------------------------
search  proc

        push    si
        push    dx
        push    cx
        push    bx
        push    ax

        push    cx
        call    getLenOfString
        mov     dx, cx
        pop     cx

        lodsb

keeplooking:                
        repnz   scasb
        stc                             ; assume error
        jcxz    failedsearch            

        ; found something.  see if the rest matches.

        push    si                      ; save the state in case 1st
        push    di                      ; letter is doubled.
        repz    cmpsb                    
        mov     bx, si
        pop     di
        pop     si

        sub     bx, si
        cmp     bx, dx                  ; length match?
        jl      keeplooking

        dec     di                      ; point to 1st byte
        clc


failedsearch:
        pop     ax
        pop     bx
        pop     cx
        pop     dx
        pop     si
        ret

search  endp

end

