comment %

ACPI support routines


%

       	.DOSSEG
        .MODEL  small, c, os_dos

.386

        extern  search:NEAR
        extern  printReg:NEAR


        INCLUDE constant.inc
        INCLUDE macros.inc


        .CODE



; entry: esi = pointer to system table
; 
;
RSDTTableDisplay proc public

       
        mov     edi, gs:[esi+4]                 ; get length in EDI
        add     edi, esi                        ; edi is now end of table

        call    displayTable                    ; display generic table



        mov     cx, 0
@@:        
        writeln 'Table '

        mov     ah, 2
        mov     dl, cl
        add     dl, "0"
        int     21h                     ; print character



        writeln ' Offset:'                 ; 4 byte table leng
        mov     eax, gs:[esi]


        push    cx
        push    bx
        shl     cx, 2                   ; make dword
        lea     bx, offset tables
        add     bx, cx
        mov     cs:[bx], eax         ; store table offset

        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '

        pop     bx
        pop     cx

        inc     cl
        cmp     esi, edi
        jnz     @b
        
        ret
RSDTTableDisplay endp

public tables

tables  dd 0,0,0,0,0,0,0,0,0,0 ; room for lotsa tables.


; Displays a generic ACPI table header
;
; entry: ESI points to structure to print.
; exit:  ESI points to next byte in table
;
; Several ACPI tables have the same header structure, so this routine saves
; code space.
;
displayTable proc public

        writeln 'Table Signature:'
        mov     cx, 4                           ; 4 bytes signature
@@:	
        mov     dl, gs:[esi]
	mov     ah,2
        int     21h
        inc     esi
   	loop 	@b
        writelnCr ' '

        writeln 'Table Length:'                 ; 4 byte table leng
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '

        writeln 'Revision:'
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '

        writeln 'Checksum:'
        mov     al, gs:[esi]
        inc     esi
        mov     cx, 2
        call    printReg
        writelncr ' '


        
        writeln 'OEM ID:'

        mov     cx, 6                           ; 4 bytes signature
@@:	
        mov     dl, gs:[esi]
	mov     ah,2
        int     21h
        inc     esi
   	loop 	@b
        writelncr ' '
        

        writeln 'OEM Table ID:'

        mov     cx, 8                           ; 8 bytes
@@:	
        mov     dl, gs:[esi]
	mov     ah,2
        int     21h
        inc     esi
   	loop 	@b
        writelncr ' '


        writeln 'OEM Revision:'                 ; 4 byte table leng
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '


        writeln 'Creator ID:'                 ; 4 byte table leng
        mov     cx, 4                           ; 4 bytes
@@:	
        mov     dl, gs:[esi]
	mov     ah,2
        int     21h
        inc     esi
   	loop 	@b
        writelncr ' '

        
        writeln 'Creator Revision:'                 ; 4 byte table leng
        mov     eax, gs:[esi]
        mov     cx, 8
        call    printReg
        add     esi, 4
        writelncr ' '
        ret
displayTable endp





.DATA





End

